include \masm32\include\masm32rt.inc

DialogProc proto :DWORD, :DWORD, :DWORD, :DWORD

.data

bReadPipe			DWORD						1

.data?

szClassName			BYTE 255 DUP				(?)
dwReadHandle		DWORD						?
dwWriteHandle		DWORD						?

PipeAttributes		SECURITY_ATTRIBUTES			<>
StartupInfo			STARTUPINFO					<>
ProcessInfo			PROCESS_INFORMATION			<>

hEdt				DWORD						?
szBuffer			BYTE 1024 DUP				(?)

hThread				DWORD						?

.const

IDD_DLG1			EQU							1000
IDC_EDT1			EQU							1001

.code
	Start:

xor ebx, ebx
	invoke GetModuleHandle, ebx
	invoke DialogBoxParam, ebx, IDD_DLG1, ebx, addr DialogProc, ebx
	invoke ExitProcess, ebx
	
ReadFromConsole proc hwnd:DWORD
LOCAL nBytesRead:DWORD

	.WHILE bReadPipe

			invoke RtlZeroMemory, addr szBuffer, 1024
			invoke ReadFile, dwReadHandle, addr szBuffer, 1023, addr nBytesRead, NULL
			
			.IF !eax
					invoke Sleep, 10
			.ELSE		
					invoke GetWindowTextLength, hEdt
					invoke SendMessage, hEdt, EM_SETSEL, eax, eax
					invoke SendMessage, hEdt, EM_REPLACESEL, FALSE, addr szBuffer
			.ENDIF
	
	.ENDW
	
		invoke TerminateProcess, ProcessInfo.hProcess, NULL
		invoke CloseHandle, ProcessInfo.hProcess
		invoke CloseHandle, dwReadHandle
	
ret
ReadFromConsole endp
	
DialogProc proc hwndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	.IF uMsg == WM_INITDIALOG
		
			invoke GetDlgItem, hwndDlg, IDC_EDT1
		mov hEdt, eax

		mov PipeAttributes.nLength, sizeof PipeAttributes
		mov PipeAttributes.lpSecurityDescriptor, NULL
		mov PipeAttributes.bInheritHandle, TRUE

			invoke CreatePipe, addr dwReadHandle, addr dwWriteHandle, addr PipeAttributes, NULL
		
		mov StartupInfo.cb, sizeof StartupInfo
			invoke GetStartupInfo, addr StartupInfo
		mov eax, dwWriteHandle
		
		mov StartupInfo.hStdOutput, eax
		mov StartupInfo.hStdError, eax
		mov StartupInfo.dwFlags, STARTF_USESHOWWINDOW OR STARTF_USESTDHANDLES
		mov StartupInfo.wShowWindow, SW_HIDE
			invoke CreateProcess, NULL, chr$("C:\Windows\System32\tracert.exe www.google.com"), NULL, NULL, TRUE, NULL, NULL, NULL, addr StartupInfo, addr ProcessInfo
			invoke CloseHandle, dwWriteHandle
			invoke CloseHandle, ProcessInfo.hThread
			
			invoke CreateThread, NULL, NULL, addr ReadFromConsole, lParam, NULL, NULL
		mov hThread, eax
		
	.ELSEIF uMsg == WM_CLOSE
	
		mov bReadPipe, 0
			invoke WaitForSingleObject, hThread, INFINITE
			invoke EndDialog, hwndDlg, NULL
		
	.ELSE
		
		mov eax, FALSE
		ret
		
	.ENDIF
	
mov eax, TRUE
ret
DialogProc endp
	
	end Start